<?php

namespace Drupal\students;

use Drupal\Core\Form\ConfirmFormBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Url;

/**
 * Class DeleteForm.
 *
 * @package Drupal\students
 */
class DeleteForm extends ConfirmFormBase {
  protected $id;

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'students_delete';
  }

  /**
   * {@inheritdoc}
   */
  public function getQuestion() {
    return $this->t('Are you sure you want to delete student %id?',
      ['%id' => $this->id]);
  }

  /**
   * {@inheritdoc}
   */
  public function getConfirmText() {
    return $this->t('Delete');
  }

  /**
   * {@inheritdoc}
   */
  public function getCancelUrl() {
    return new Url('students_list');
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    $this->id = \Drupal::request()->get('id');
    return parent::buildForm($form, $form_state);
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    StudentsStorage::delete($this->id);
    \Drupal::messenger()->addMessage($this->t('The student is removed.'));
    $form_state->setRedirect('students_list');
  }

}
